#pragma once

#include "CoreMinimal.h"
#include "Components/ActorComponent.h"
#include "YawAndPitchRotator_NetQuantize16.h"
#include "EDirectionalInputKey.h"
#include "K40SecurityCameraSurvivorComponent.generated.h"

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class UK40SecurityCameraSurvivorComponent : public UActorComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _cameraRotationNetUpdateFrequency;

public:
	UFUNCTION(BlueprintCallable, Server, Reliable)
	void Server_SetCameraToTargetByDoorID(const uint8 doorID);

private:
	UFUNCTION(BlueprintCallable, Server, Unreliable)
	void Server_SetCameraActorRotation(const FYawAndPitchRotator_NetQuantize16& newActorRotation);

public:
	UFUNCTION(BlueprintCallable, Server, Reliable)
	void Server_OnCameraDirectionInputPressed(const EDirectionalInputKey directionalInput);

public:
	UK40SecurityCameraSurvivorComponent();
};

FORCEINLINE uint32 GetTypeHash(const UK40SecurityCameraSurvivorComponent) { return 0; }
